document.addEventListener('DOMContentLoaded', function() {
    var trackingClasses = clickTrackerData.tracking_classes;

    trackingClasses.forEach(function(trackingClass) {
        var className = trackingClass.class_name;
        var tag = trackingClass.tag;
        var groupName = trackingClass.group_name;

        var elements = document.querySelectorAll('a.' + className);
        elements.forEach(function(element) {
            element.addEventListener('click', function(event) {
                var url = element.href;
                var data = {
                    action: 'click_tracker_track_click',
                    security: clickTrackerData.nonce,
                    class_name: className,
                    tag: tag,
                    group_name: groupName,
                    url: url,
                };

                var xhr = new XMLHttpRequest();
                xhr.open('POST', clickTrackerData.ajax_url, true);
                xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded; charset=UTF-8');
                xhr.send(encodeFormData(data));
            });
        });
    });

    function encodeFormData(data) {
        var pairs = [];
        for (var name in data) {
            if (!data.hasOwnProperty(name)) continue;
            pairs.push(encodeURIComponent(name) + '=' + encodeURIComponent(data[name]));
        }
        return pairs.join('&');
    }
});
